  
#ifndef _imagertask_cmpt_h_
#define _imagertask_cmpt_h_

#include <vector>
#include <string>
#include <complex>
#include <stdcasa/record.h>
#include <tools/casaswig_types.h>
#include <casa/Exceptions/Error.h>

using namespace std;

namespace casac {
           


   class  imagertask  {
       public :


         ~imagertask();
         imagertask();

         void clean(const  string& vis=string("Unknown"), const  string& alg=string("clark"),  long  niter=1000, 
			  double gain=0.1, 
			  double threshold=0.0,  const std::vector<std::string>& residual=std::vector<string>(1, ""),  const std::vector<std::string>& image=std::vector<string>(1, ""),  const std::vector<std::string>& model=std::vector<string>(1, ""),  const std::vector<std::string>& mask=std::vector<string>(1, ""), const  string& mode=string(""),  const std::vector<long>& nchan=initialize_vector(1, (long)1),  const std::vector<long>& start=initialize_vector(1, (long)1),  const std::vector<long>& width=initialize_vector(1, (long)1),  const std::vector<long>& step=initialize_vector(1, (long)1),  const std::vector<long>& imsize=initialize_vector(2,(long)128, (long)128),  const std::vector<long>& cell=initialize_vector(2,(long)1, (long)1), const  string& stokes=string("I"),  const std::vector<long>& fieldid=initialize_vector(1, (long)1),  const std::vector<long>& spwid=initialize_vector(1, (long)1), const  string& weighting=string("uniform"), const  string& rmode=string("none"), 
			  double robust=0.0);

         void feather(const  string& vis=string(""), const  string& featherimage=string(""), const  string& highres=string(""), const  string& lowres=string(""), const  string& lowpsf=string(""));

         void invert(const  string& vis=string(""), const  string& map=string(""), const  string& beam=string(""), const  string& mode=string(""),  const std::vector<long>& nchan=initialize_vector(1, (long)1),  const std::vector<long>& start=initialize_vector(1, (long)1),  const std::vector<long>& width=initialize_vector(1, (long)1),  const std::vector<long>& step=initialize_vector(1, (long)1),  const std::vector<long>& imsize=initialize_vector(2,(long)128, (long)128),  const std::vector<long>& cell=initialize_vector(2,(long)1, (long)1), const  string& stokes=string("I"),  const std::vector<long>& fieldid=initialize_vector(1, (long)1),  const std::vector<long>& spwid=initialize_vector(1, (long)1), const  string& weighting=string("uniform"), const  string& rmode=string("none"), 
			  double robust=0.0);

         void mosaic(const  string& vis=string(""), const  string& alg=string("mfclark"),  long  niter=1000, 
			  double gain=0.1, 
			  double threshold=0.0,  const std::vector<std::string>& residual=std::vector<string>(1, ""),  const std::vector<std::string>& image=std::vector<string>(1, ""),  const std::vector<std::string>& model=std::vector<string>(1, ""),  const std::vector<std::string>& mask=std::vector<string>(1, ""), const  string& mode=string(""), const  string& gridfn=string("SF"), const  string& grid=string("mosaic"),  const std::vector<long>& nchan=initialize_vector(1, (long)1),  const std::vector<long>& start=initialize_vector(1, (long)1),  const std::vector<long>& width=initialize_vector(1, (long)1),  const std::vector<long>& step=initialize_vector(1, (long)1),  const std::vector<long>& imsize=initialize_vector(2,(long)128, (long)128),  const std::vector<long>& cell=initialize_vector(2,(long)1, (long)1), const  string& stokes=string("I"),  const std::vector<long>& fieldid=initialize_vector(1, (long)1),  long  reffieldid=1,  const std::vector<long>& spwid=initialize_vector(1, (long)1), const  string& weighting=string("uniform"), const  string& mosweight=string("T"), const  string& rmode=string("none"), 
			  double robust=0.0, 
			  double minpb=0.1, const  string& scaletype=string("NONE"),  long  stoplargenegatives=-1, 
			  double cyclefactor=1.5, 
			  double cyclespeedup=2.0);


      private :

   }; 

 
}
#endif
