  
#ifndef _msmetadata_cmpt_h_
#define _msmetadata_cmpt_h_

#include <vector>
#include <string>
#include <complex>
#include <stdcasa/record.h>
#include <tools/casaswig_types.h>
#include <casa/Exceptions/Error.h>
#include <tools/ms/msmetadata_forward.h>

using namespace std;

namespace casac {
           


   class  msmetadata  {
       public :


         ~msmetadata();
         msmetadata();

         std::vector<long> almaspws( bool  chavg=false,  bool  fdm=false,  bool  sqld=false,  bool  tdm=false,  bool  wvr=false,  bool  complement=false);

         record* antennadiameter( const variant & antenna = variant());

         std::vector<long> antennaids( const variant & name = variant(),  const variant & mindiameter = variant(),  const variant & maxdiameter = variant(),  long  obsid=-1);

         std::vector<std::string> antennanames( const variant & antennaids = variant());

         record* antennaoffset( const variant & which = variant());

         record* antennaposition( const variant & which = variant());

         std::vector<std::string> antennastations( const variant & which = variant(),  long  obsid=-1);

         std::vector<long> antennasforscan( long  scan=-1,  long  obsid=-1,  long  arrayid=-1);

         variant* bandwidths( const variant & spw = variant());

         long baseband( long  spw);

         variant* baselines();

         std::vector<long> chanavgspws();

         std::vector<double>chaneffbws( long  spw,  const string& unit=string(""),  bool  asvel=false);

         std::vector<double>chanfreqs( long  spw,  const string& unit=string("Hz"));

         std::vector<double>chanres( long  spw,  const string& unit=string(""),  bool  asvel=false);

         std::vector<double>chanwidths( long  spw,  const string& unit=string("Hz"));

         bool close();

         variant* corrprodsforpol( long  pol=-1);

         std::vector<long> corrtypesforpol( long  pol=-1);

         std::vector<long> datadescids( long  spw=-1,  long  pol=-1);

         bool done();

         record* effexposuretime();

         record* exposuretime( long  scan=0,  long  spwid=0,  long  polid=-1,  long  obsid=0,  long  arrayid=0);

         std::vector<long> fdmspws();

         std::vector<std::string> fieldnames();

         variant* fieldsforintent( const string& intent=string(""),  bool  asnames=false);

         std::vector<long> fieldsforname( const string& name=string(""));

         variant* fieldsforscan( long  scan=-1,  bool  asnames=false,  long  obsid=-1,  long  arrayid=-1);

         variant* fieldsforscans( const std::vector<long>& scans=std::vector<long>() ,  bool  asnames=false,  long  obsid=-1,  long  arrayid=-1,  bool  asmap=false);

         variant* fieldsforsource( long  source=-1,  bool  asnames=false);

         record* fieldsforsources( bool  asnames=false);

         variant* fieldsforspw( long  spw=-1,  bool  asnames=false);

         std::vector<long> fieldsfortimes(
			  double time=-1, 
			  double tol=0);

         std::vector<std::string> intents();

         std::vector<std::string> intentsforfield( const variant & field = variant());

         std::vector<std::string> intentsforscan( long  scan=-1,  long  obsid=-1,  long  arrayid=-1);

         std::vector<std::string> intentsforspw( long  spw=-1);

         double meanfreq( long  spw,  const string& unit=string("Hz"));

         string name();

         std::vector<std::string> namesforfields( const variant & fieldids = variant());

         std::vector<std::string> namesforspws( const variant & spwids = variant());

         long nantennas();

         long narrays();

         long nbaselines( bool  ac=false);

         long nchan( long  spw);

         variant* ncorrforpol( long  polid=-1);

         long nfields();

         long nobservations();

         long nspw( bool  includewvr=true);

         long nstates();

         long nscans();

         long nsources();

         double nrows( bool  autoc=true,  bool  flagged=true);

         std::vector<std::string> observers();

         std::vector<std::string> observatorynames();

         record* observatoryposition( long  which=0);

         bool open( const string& msfile=string(""),  float  maxcache=50);

         record* phasecenter( long  fieldid=0,  const record& epoch=initialize_record("") );

         record* pointingdirection( long  rownum=0,  bool  interpolate=false,  long  initialrow=0);

         variant* polidfordatadesc( long  ddid=-1);

         std::vector<std::string> projects();

         record* propermotions();

         record* refdir( const variant & field = variant(),  const record& epoch=initialize_record("") );

         record* reffreq( long  spw=-1);

         variant* restfreqs( long  sourceid=0,  long  spw=0);

         std::vector<long> scannumbers( long  obsid=-1,  long  arrayid=-1);

         std::vector<long> scansforfield( const variant & field = variant(),  long  obsid=-1,  long  arrayid=-1);

         record* scansforfields( long  obsid=0,  long  arrayid=0);

         std::vector<long> scansforintent( const string& intent=string(""),  long  obsid=-1,  long  arrayid=-1);

         std::vector<long> scansforspw( long  spw=-1,  long  obsid=-1,  long  arrayid=-1);

         record* scansforspws( long  obsid=0,  long  arrayid=0);

         std::vector<long> scansforstate( long  state=-1,  long  obsid=-1,  long  arrayid=-1);

         std::vector<long> scansfortimes(
			  double time=-1, 
			  double tol=0,  long  obsid=-1,  long  arrayid=-1);

         std::vector<std::string> schedule( long  obsid=-1);

         long sideband( long  spw);

         record* sourcedirs();

         record* sourcetimes();

         long sourceidforfield( long  field=-1);

         std::vector<long> sourceidsfromsourcetable();

         std::vector<std::string> sourcenames();

         variant* spwsforbaseband( long  baseband=-1,  const string& sqldmode=string("include"));

         variant* spwfordatadesc( long  ddid=-1);

         std::vector<long> spwsforfield( const variant & field = variant());

         record* spwsforfields();

         std::vector<long> spwsforintent( const string& intent=string(""));

         record* spwsfornames( const variant & spwids = variant());

         std::vector<long> spwsforscan( long  scan=-1,  long  obsid=-1,  long  arrayid=-1);

         record* spwsforscans( long  obsid=0,  long  arrayid=0);

         std::vector<long> statesforscan( long  scan=-1,  long  obsid=-1,  long  arrayid=-1);

         record* statesforscans( long  obsid=0,  long  arrayid=0);

         record* summary();

         std::vector<long> tdmspws();

         record* timerangeforobs( long  obsid=-1);

         std::vector<double>timesforfield( long  field=-1);

         std::vector<double>timesforintent( const string& intent=string(""));

         variant* timesforscan( long  scan=-1,  long  obsid=-1,  long  arrayid=-1,  bool  perspw=false);

         std::vector<double>timesforscans( const variant & scans= variant(),  long  obsid=-1,  long  arrayid=-1);

         variant* timesforspws( const variant & spw= variant());

         variant* transitions( long  sourceid=0,  long  spw=0);

         std::vector<long> wvrspws( bool  complement=false);


      private :
#include <tools/ms/msmetadata_private.h>
   }; 

 
}
#endif
