  
#ifndef _synthesisutils_cmpt_h_
#define _synthesisutils_cmpt_h_

#include <vector>
#include <string>
#include <complex>
#include <stdcasa/record.h>
#include <tools/casaswig_types.h>
#include <casa/Exceptions/Error.h>
#include <synthesisimstore_cmpt.h>
#include <tools/synthesis/synthesisutils_forward.h>

using namespace std;

namespace casac {
           


   class  synthesisutils  {
       public :


         ~synthesisutils();
         synthesisutils();

         record* contdatapartition( const record& selpars=initialize_record("") ,  long  npart=1);

         record* advisechansel( const variant & freqstart = variant(),  const variant & freqend = variant(),  const variant & freqstep = variant(),  const string& freqframe=string("LSRK"),  const string& ephemtable=string(""),  const string& msname=string(""),  long  fieldid=0,  bool  getfreqrange=false, const  string& spwselection=string(""));

         record* cubedatapartition( const record& selpars=initialize_record("") ,  long  npart=1,  const variant & fstart= variant(),  const variant & fend= variant(), const  string& frame=string("LSRK"));

         record* cubeimagepartition( const record& impars=initialize_record("") ,  long  npart=1);

         record* cubedataimagepartition( const record& selpars=initialize_record("") ,  const record& incsys=initialize_record("") ,  long  npart=1,  long  nchannel=1);

         record* checkselectionparams( const record& selpars=initialize_record("") );

         record* checkimageparams( const record& impars=initialize_record("") );

         record* checkgridparams( const record& gridpars=initialize_record("") );

         record* updateimpars( const record& impars=initialize_record("") );

         long getOptimumSize( long  size=100);

         bool fitPsfBeam(const  string& imagename=string(""),  long  nterms=1,  float  psfcutoff=0.35);

         bool done();


      private :
#include <tools/synthesis/synthesisutils_private.h>
   }; 

 
}
#endif
